import * as widgets from '@jupyter-widgets/base';
import 'd3-selection-multi';
import { MarkModel } from './MarkModel';
export declare abstract class Mark extends widgets.WidgetView {
    initialize(): void;
    render(): Promise<void>;
    abstract draw(animate?: any): any;
    abstract set_ranges(): any;
    set_scale_views(): Promise<void>;
    set_positional_scales(): void;
    initialize_additional_scales(): void;
    set_internal_scales(): void;
    create_listeners(): void;
    remove(): void;
    draw_legend(elem: any, x_disp: any, y_disp: any, inter_x_disp: any, inter_y_disp: any): number[];
    highlight_axes(): void;
    unhighlight_axes(): void;
    relayout(): void;
    invert_range(start_pxl: any, end_pxl: any): any[];
    invert_point(pxl: any): void;
    invert_multi_range(array_pixels: any): any;
    update_visibility(model: any, visible: any): void;
    get_colors(index: any): any;
    selected_style_updated(model: any, style: any): void;
    unselected_style_updated(model: any, style: any): void;
    style_updated(new_style: any, indices: any, elements?: any): void;
    apply_styles(style_arr?: any): void;
    abstract clear_style(style_dict: any, indices?: any, elements?: any): any;
    abstract set_default_style(indices: any, elements?: any): any;
    abstract set_style_on_elements(style: any, indices: any, elements?: any): any;
    /**
     * This function sets the x and y view paddings for the mark using the
     * variables x_padding and y_padding
     */
    abstract compute_view_padding(): any;
    show_tooltip(mouse_events?: any): void;
    move_tooltip(mouse_events?: any): void;
    hide_tooltip(): void;
    refresh_tooltip(tooltip_interactions?: boolean): void;
    create_tooltip(): void;
    event_dispatcher(event_name: any, data?: any): void;
    custom_msg_sender(event_name: any): void;
    reset_click(): void;
    private reset_hover;
    private reset_legend_click;
    private reset_legend_hover;
    process_click(interaction: any): void;
    process_hover(interaction: any): void;
    process_legend_click(interaction: any): void;
    process_legend_hover(interaction: any): void;
    process_interactions(): void;
    mouse_over(): void;
    mouse_out(): void;
    mouse_move(): void;
    is_hover_element(elem: any): boolean;
    bisect: any;
    colors: any;
    d3el: any;
    display_el_classes: string[];
    event_listeners: any;
    event_metadata: any;
    parent: any;
    scales: any;
    selected_indices: any;
    selected_style: any;
    tooltip_div: any;
    tooltip_view: any;
    unselected_style: any;
    uuid: any;
    x_padding: any;
    y_padding: any;
    model: MarkModel;
}
